using System;
using System.Collections.Generic;
using System.Runtime.InteropServices;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Drawing.Imaging;

namespace MyImageProcessor
{
    public class MyImageProcessing
    {

        public string LoadImage(string filename)
        {
            try
            {
                this._image = Image.FromFile(filename);
            }
            catch (Exception e)
            {

                return e.ToString();
            }

            return "ok";
        }

        public string RotateImage(float degrees)
        {
            try
            {
                _image = this.rotateImage((Bitmap)_image, degrees);
            }
            catch (Exception e)
            {

                return e.ToString();
            }

            return "ok";
        }

        public string SaveImage(string filename)
        {
            try
            {
                saveJpeg(filename, new Bitmap(this._image), 85L);
            }
            catch (Exception e)
            {

                return e.ToString();
            }

            return "ok";
        }



        private void saveJpeg(string path, Bitmap img, long quality)
        {
            // Encoder parameter for image quality
            EncoderParameter qualityParam =
                new EncoderParameter(Encoder.Quality, quality);

            // Jpeg image codec
            ImageCodecInfo jpegCodec = getEncoderInfo("image/jpeg");

            if (jpegCodec == null)
                return;

            EncoderParameters encoderParams = new EncoderParameters(1);
            encoderParams.Param[0] = qualityParam;

            img.Save(path, jpegCodec, encoderParams);
        }

        private Bitmap rotateImage(Bitmap b, float angle)
        {
            //create a new empty bitmap to hold rotated image
            Bitmap returnBitmap = new Bitmap(b.Width, b.Height);
         
            //make a graphics object from the empty bitmap
            Graphics g = Graphics.FromImage(returnBitmap);
            //move rotation point to center of image
           // g.TranslateTransform((float)b.Width / 2, (float)b.Height / 2);
            //rotate
            g.RotateTransform(angle);
            //move image back
          //  g.TranslateTransform(-(float)b.Width / 2, -(float)b.Height / 2);
            //draw passed in image onto graphics object
            g.DrawImage(b, new Point(0, 0));
           // Bitmap returnBitmapRet = new Bitmap(b.Width, b.Height);
            return returnBitmap;
        }

        private ImageCodecInfo getEncoderInfo(string mimeType)
        {
            // Get image codecs for all image formats
            ImageCodecInfo[] codecs = ImageCodecInfo.GetImageEncoders();

            // Find the correct image codec
            for (int i = 0; i < codecs.Length; i++)
                if (codecs[i].MimeType == mimeType)
                    return codecs[i];
            return null;
        }

        private Image _image;
    }
}
